orte/mca/pls/bproc_orted/pls_bproc_orted.c File Reference.TH "orte/mca/pls/bproc_orted/pls_bproc_orted.c" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
orte/mca/pls/bproc_orted/pls_bproc_orted.c \- Part of the bproc launcher. 
.SH SYNOPSIS
.br
.PP
\fC#include 'orte_config.h'\fP
.br
\fC#include <stdlib.h>\fP
.br
\fC#include <unistd.h>\fP
.br
\fC#include <sys/types.h>\fP
.br
\fC#include <fcntl.h>\fP
.br
\fC#include <pty.h>\fP
.br
\fC#include <dirent.h>\fP
.br
\fC#include 'opal/mca/base/mca_base_param.h'\fP
.br
\fC#include 'opal/runtime/opal_progress.h'\fP
.br
\fC#include 'opal/threads/condition.h'\fP
.br
\fC#include 'opal/util/os_create_dirpath.h'\fP
.br
\fC#include 'opal/util/os_path.h'\fP
.br
\fC#include 'opal/util/output.h'\fP
.br
\fC#include 'orte/util/sys_info.h'\fP
.br
\fC#include 'orte/include/orte_constants.h'\fP
.br
\fC#include 'orte/mca/errmgr/errmgr.h'\fP
.br
\fC#include 'orte/mca/gpr/gpr.h'\fP
.br
\fC#include 'orte/mca/iof/iof.h'\fP
.br
\fC#include 'orte/mca/iof/base/iof_base_setup.h'\fP
.br
\fC#include 'orte/mca/ns/base/base.h'\fP
.br
\fC#include 'orte/mca/oob/base/base.h'\fP
.br
\fC#include 'orte/mca/pls/base/base.h'\fP
.br
\fC#include 'orte/mca/rmaps/base/rmaps_base_map.h'\fP
.br
\fC#include 'orte/util/session_dir.h'\fP
.br
\fC#include 'orte/util/univ_info.h'\fP
.br
\fC#include 'pls_bproc_orted.h'\fP
.br

.SS "Functions"

.in +1c
.ti -1c
.RI "static int \fBpls_bproc_orted_make_dir\fP (char *directory)"
.br
.RI "\fICreates the passed directory. \fP"
.ti -1c
.RI "static char * \fBpls_bproc_orted_get_base_dir_name\fP (int proc_rank, \fBorte_jobid_t\fP jobid, size_t app_context)"
.br
.RI "\fIReturns a path of the form: 
.PP
.nf
 /tmp/openmpi-bproc-<user>/<universe>/<jobid>-<app_context>/<proc_rank>/

.fi
.PP
 which is used to put links to the pty/pipes in. \fP"
.ti -1c
.RI "static int \fBpls_bproc_orted_link_pipes\fP (int proc_rank, \fBorte_jobid_t\fP jobid, int *fd, bool connect_stdin, size_t app_context)"
.br
.RI "\fIcreates pipes for the io in the filesystem in the directory 
.PP
.nf
 /tmp/openmpi-bproc-<user>/<universe>/<jobid>-<app_context>/<proc_rank>/

.fi
.PP
 and returns their file descriptors \fP"
.ti -1c
.RI "static void \fBpls_bproc_orted_delete_dir_tree\fP (char *path)"
.br
.RI "\fIdeletes the passed directory tree recursively \fP"
.ti -1c
.RI "static int \fBpls_bproc_orted_remove_dir\fP (void)"
.br
.RI "\fIRemoves the bproc directory 
.PP
.nf
 /tmp/openmpi-bproc-<user>/ 

.fi
.PP
 and all of its contents. \fP"
.ti -1c
.RI "static void \fBpls_bproc_orted_send_cb\fP (int status, orte_process_name_t *peer, \fBorte_buffer_t\fP *buffer, int tag, void *cbdata)"
.br
.RI "\fICallback function for when we tell mpirun we are ready. \fP"
.ti -1c
.RI "int \fBorte_pls_bproc_orted_launch\fP (\fBorte_jobid_t\fP jobid)"
.br
.RI "\fISetup io for the current node, then tell orterun we are ready for the actual processes. \fP"
.ti -1c
.RI "int \fBorte_pls_bproc_orted_terminate_job\fP (\fBorte_jobid_t\fP jobid)"
.br
.RI "\fIFunction to terminate a job. \fP"
.ti -1c
.RI "int \fBorte_pls_bproc_orted_terminate_proc\fP (const orte_process_name_t *proc)"
.br
.RI "\fIFunction to terminate a process. \fP"
.ti -1c
.RI "int \fBorte_pls_bproc_orted_finalize\fP (void)"
.br
.RI "\fIFinalizes the bproc_orted module. \fP"
.in -1c
.SS "Variables"

.in +1c
.ti -1c
.RI "\fBorte_pls_base_module_1_0_0_t\fP \fBorte_pls_bproc_orted_module\fP"
.br
.RI "\fIInitialization of the bproc_orted module with all the needed function pointers. \fP"
.in -1c
.SH "Detailed Description"
.PP 
Part of the bproc launcher. 

See \fBpls_bproc_orted.h\fP for an overview of how it works.
.SH "Function Documentation"
.PP 
.SS "int orte_pls_bproc_orted_finalize (void)"
.PP
Finalizes the bproc_orted module. 
.PP
Cleanup tmp directory/files used for I/O forwarding. 
.PP
\fBReturn values:\fP
.RS 4
\fIORTE_SUCCESS\fP 
.RE
.PP

.SS "int orte_pls_bproc_orted_launch (\fBorte_jobid_t\fP jobid)"
.PP
Setup io for the current node, then tell orterun we are ready for the actual processes. 
.PP
\fBParameters:\fP
.RS 4
\fIjobid\fP The jobid of the job to launch 
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIORTE_SUCCESS\fP .br
\fIerror\fP .RE
.PP

.SS "int orte_pls_bproc_orted_terminate_job (\fBorte_jobid_t\fP jobid)"
.PP
Function to terminate a job. 
.PP
Since this component only runs on remote nodes and doesn't actually launch any processes, this function is not needed so is a noop. 
.PP
\fBParameters:\fP
.RS 4
\fIjobid\fP The job to terminate 
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIORTE_SUCCESS\fP .RE
.PP

.SS "int orte_pls_bproc_orted_terminate_proc (const orte_process_name_t * proc)"
.PP
Function to terminate a process. 
.PP
Since this component only runs on remote nodes and doesn't actually launch any processes, this function is not needed so is a noop. 
.PP
\fBParameters:\fP
.RS 4
\fIproc\fP the process's name 
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIORTE_SUCCESS\fP .RE
.PP

.SS "static void pls_bproc_orted_delete_dir_tree (char * path)\fC [static]\fP"
.PP
deletes the passed directory tree recursively 
.PP
\fBParameters:\fP
.RS 4
\fIpath\fP the path to the base directory to delete 
.RE
.PP

.SS "static char * pls_bproc_orted_get_base_dir_name (int proc_rank, \fBorte_jobid_t\fP jobid, size_t app_context)\fC [static]\fP"
.PP
Returns a path of the form: 
.PP
.nf
 /tmp/openmpi-bproc-<user>/<universe>/<jobid>-<app_context>/<proc_rank>/

.fi
.PP
 which is used to put links to the pty/pipes in. 
.PP
\fBParameters:\fP
.RS 4
\fIproc_rank\fP the process's rank on the node 
.br
\fIjobid\fP the jobid the proc belongs to 
.br
\fIapp_context\fP the application context number within the job 
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIpath\fP .RE
.PP

.SS "static int pls_bproc_orted_link_pipes (int proc_rank, \fBorte_jobid_t\fP jobid, int * fd, bool connect_stdin, size_t app_context)\fC [static]\fP"
.PP
creates pipes for the io in the filesystem in the directory 
.PP
.nf
 /tmp/openmpi-bproc-<user>/<universe>/<jobid>-<app_context>/<proc_rank>/

.fi
.PP
 and returns their file descriptors 
.PP
\fBParameters:\fP
.RS 4
\fIproc_rank\fP the process's rank on the node 
.br
\fIjobid\fP the jobid the proc belongs to 
.br
\fIfd\fP a pointer to an array of file descriptors 3 long 
.br
\fIconnect_stdin\fP if true, stdin will be connected, otherwise it will be set to /dev/null 
.br
\fIapp_context\fP the application context number within the job 
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIORTE_SUCCESS\fP .br
\fIerror\fP .RE
.PP

.SS "static int pls_bproc_orted_make_dir (char * directory)\fC [static]\fP"
.PP
Creates the passed directory. 
.PP
If the directory already exists, it and its contents will be deleted then the directory will be created. 
.PP
\fBParameters:\fP
.RS 4
\fIdirectory\fP The directory to be created. 
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIORTE_SUCCESS\fP .br
\fIerror\fP .RE
.PP

.SS "static int pls_bproc_orted_remove_dir (void)\fC [static]\fP"
.PP
Removes the bproc directory 
.PP
.nf
 /tmp/openmpi-bproc-<user>/ 

.fi
.PP
 and all of its contents. 
.PP
\fBReturn values:\fP
.RS 4
\fIORTE_SUCCESS\fP .br
\fIerror\fP .RE
.PP

.SS "static void pls_bproc_orted_send_cb (int status, orte_process_name_t * peer, \fBorte_buffer_t\fP * buffer, int tag, void * cbdata)\fC [static]\fP"
.PP
Callback function for when we tell mpirun we are ready. 
.PP
\fBParameters:\fP
.RS 4
\fIstatus\fP .br
\fIpeer\fP .br
\fIbuffer\fP .br
\fItag\fP .br
\fIcbdata\fP .RE
.PP

.SH "Variable Documentation"
.PP 
.SS "\fBorte_pls_base_module_1_0_0_t\fP \fBorte_pls_bproc_orted_module\fP"
.PP
\fBInitial value:\fP
.PP
.nf
 {
    orte_pls_bproc_orted_launch,
    orte_pls_bproc_orted_terminate_job,
    orte_pls_bproc_orted_terminate_proc,
    orte_pls_bproc_orted_finalize
}
.fi
Initialization of the bproc_orted module with all the needed function pointers. 
.PP
.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
